Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkSmoothPolyDataFilter Class Reference

`#include <vtkSmoothPolyDataFilter.h>`

Inheritance diagram for vtkSmoothPolyDataFilter:

[legend]
Collaboration diagram for vtkSmoothPolyDataFilter:

[legend]
List of all members.

## Detailed Description

Date:
  2002/01/22 15:29:45

Revision:
  1.23

vtkSmoothPolyDataFilter.h is a filter that adjusts point coordinates using Laplacian smoothing. The effect is to "relax" the mesh, making the cells better shaped and the vertices more evenly distributed. Note that this filter operates on the lines, polygons, and triangle strips composing an instance of vtkPolyData. Vertex or poly-vertex cells are never modified.

The algorithm proceeds as follows. For each vertex v, a topological and geometric analysis is performed to determine which vertices are connected to v, and which cells are connected to v. Then, a connectivity array is constructed for each vertex. (The connectivity array is a list of lists of vertices that directly attach to each vertex.) Next, an iteration phase begins over all vertices. For each vertex v, the coordinates of v are modified according to an average of the connected vertices. (A relaxation factor is available to control the amount of displacement of v). The process repeats for each vertex. This pass over the list of vertices is a single iteration. Many iterations (generally around 20 or so) are repeated until the desired result is obtained.

There are some special instance variables used to control the execution of this filter. (These ivars basically control what vertices can be smoothed, and the creation of the connectivity array.) The BoundarySmoothing ivar enables/disables the smoothing operation on vertices that are on the "boundary" of the mesh. A boundary vertex is one that is surrounded by a semi-cycle of polygons (or used by a single line).

Another important ivar is FeatureEdgeSmoothing. If this ivar is enabled, then interior vertices are classified as either "simple", "interior edge", or "fixed", and smoothed differently. (Interior vertices are manifold vertices surrounded by a cycle of polygons; or used by two line cells.) The classification is based on the number of feature edges attached to v. A feature edge occurs when the angle between the two surface normals of a polygon sharing an edge is greater than the FeatureAngle ivar. Then, vertices used by no feature edges are classified "simple", vertices used by exactly two feature edges are classified "interior edge", and all others are "fixed" vertices.

Once the classification is known, the vertices are smoothed differently. Corner (i.e., fixed) vertices are not smoothed at all. Simple vertices are smoothed as before (i.e., average of connected vertex coordinates). Interior edge vertices are smoothed only along their two connected edges, and only if the angle between the edges is less than the EdgeAngle ivar.

The total smoothing can be controlled by using two ivars. The NumberOfIterations is a cap on the maximum number of smoothing passes. The Convergence ivar is a limit on the maximum point motion. If the maximum motion during an iteration is less than Convergence, then the smoothing process terminates. (Convergence is expressed as a fraction of the diagonal of the bounding box.)

There are two instance variables that control the generation of error data. If the ivar GenerateErrorScalars is on, then a scalar value indicating the distance of each vertex from its original position is computed. If the ivar GenerateErrorVectors is on, then a vector representing change in position is computed.

Optionally you can further control the smoothing process by defining a second input: the Source. If defined, the input mesh is constrained to lie on the surface defined by the Source ivar.

Warning:
  The Laplacian operation reduces high frequency information in the geometry of the mesh. With excessive smoothing important details may be lost, and the surface may shrink towards the centroid. Enabling FeatureEdgeSmoothing helps reduce this effect, but cannot entirely eliminate it. You may also wish to try vtkWindowedSincPolyDataFilter. It does a better job of minimizing shrinkage.

See also:
  vtkWindowedSincPolyDataFilter vtkDecimate vtkDecimatePro

Created by:
  - Lorensen, Bill

CVS contributions (if > 5%):
  - Lorensen, Bill (63%)
  - Schroeder, Will (24%)

CVS logs (CVSweb):
  - .`h` (`/Graphics/vtkSmoothPolyDataFilter.h)`
  - .`cxx` (`/Graphics/vtkSmoothPolyDataFilter.cxx)`

Examples:
  vtkSmoothPolyDataFilter (Examples)

Tests:
  vtkSmoothPolyDataFilter (Tests)

Definition at line 119 of file vtkSmoothPolyDataFilter.h.

## Public Types
typedef vtkPolyDataToPolyDataFilter | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
virtual void | SetConvergence (float)
virtual float | GetConvergence ()
virtual void | SetNumberOfIterations (int)
virtual int | GetNumberOfIterations ()
virtual void | SetRelaxationFactor (float)
virtual float | GetRelaxationFactor ()
virtual void | SetFeatureEdgeSmoothing (int)
virtual int | GetFeatureEdgeSmoothing ()
virtual void | FeatureEdgeSmoothingOn ()
virtual void | FeatureEdgeSmoothingOff ()
virtual void | SetFeatureAngle (float)
virtual float | GetFeatureAngle ()
virtual void | SetEdgeAngle (float)
virtual float | GetEdgeAngle ()
virtual void | SetBoundarySmoothing (int)
virtual int | GetBoundarySmoothing ()
virtual void | BoundarySmoothingOn ()
virtual void | BoundarySmoothingOff ()
virtual void | SetGenerateErrorScalars (int)
virtual int | GetGenerateErrorScalars ()
virtual void | GenerateErrorScalarsOn ()
virtual void | GenerateErrorScalarsOff ()
virtual void | SetGenerateErrorVectors (int)
virtual int | GetGenerateErrorVectors ()
virtual void | GenerateErrorVectorsOn ()
virtual void | GenerateErrorVectorsOff ()
void | SetSource (vtkPolyData *source)
vtkPolyData * | GetSource ()
## Static Public Methods
int | IsTypeOf (const char *type)
vtkSmoothPolyDataFilter * | SafeDownCast (vtkObject *o)
vtkSmoothPolyDataFilter * | New ()
## Protected Methods
| vtkSmoothPolyDataFilter ()
| ~vtkSmoothPolyDataFilter ()
void | Execute ()
## Protected Attributes
float | Convergence
int | NumberOfIterations
float | RelaxationFactor
int | FeatureEdgeSmoothing
float | FeatureAngle
float | EdgeAngle
int | BoundarySmoothing
int | GenerateErrorScalars
int | GenerateErrorVectors
vtkSmoothPoints * | SmoothPoints

## Member Typedef Documentation

typedef vtkPolyDataToPolyDataFilter vtkSmoothPolyDataFilter::Superclass

| Reimplemented from vtkPolyDataToPolyDataFilter. Definition at line 122 of file vtkSmoothPolyDataFilter.h.

## Constructor & Destructor Documentation

vtkSmoothPolyDataFilter::vtkSmoothPolyDataFilter | ( |  | ) | `[protected]`

vtkSmoothPolyDataFilter::~vtkSmoothPolyDataFilter | ( |  | ) | `[inline, protected]`

| Definition at line 206 of file vtkSmoothPolyDataFilter.h.

## Member Function Documentation

virtual const char* vtkSmoothPolyDataFilter::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkPolyDataToPolyDataFilter.

int vtkSmoothPolyDataFilter::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataToPolyDataFilter.

virtual int vtkSmoothPolyDataFilter::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataToPolyDataFilter.

vtkSmoothPolyDataFilter* vtkSmoothPolyDataFilter::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkPolyDataToPolyDataFilter.

void vtkSmoothPolyDataFilter::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkPolyDataToPolyDataFilter.

vtkSmoothPolyDataFilter* vtkSmoothPolyDataFilter::New | ( |  | ) | `[static]`

| Construct object with number of iterations 20; relaxation factor .01; feature edge smoothing turned off; feature angle 45 degrees; edge angle 15 degrees; and boundary smoothing turned on. Error scalars and vectors are not generated (by default). The convergence criterion is 0.0 of the bounding box diagonal. Reimplemented from vtkObject.

virtual void vtkSmoothPolyDataFilter::SetConvergence | ( | float |  | ) | `[virtual]`

| Specify a convergence criterion for the iteration process. Smaller numbers result in more smoothing iterations.

virtual float vtkSmoothPolyDataFilter::GetConvergence | ( |  | ) | `[virtual]`

| Specify a convergence criterion for the iteration process. Smaller numbers result in more smoothing iterations.

virtual void vtkSmoothPolyDataFilter::SetNumberOfIterations | ( | int |  | ) | `[virtual]`

| Specify the number of iterations for Laplacian smoothing,

virtual int vtkSmoothPolyDataFilter::GetNumberOfIterations | ( |  | ) | `[virtual]`

| Specify the number of iterations for Laplacian smoothing,

virtual void vtkSmoothPolyDataFilter::SetRelaxationFactor | ( | float |  | ) | `[virtual]`

| Specify the relaxation factor for Laplacian smoothing. As in all iterative methods, the stability of the process is sensitive to this parameter. In general, small relaxation factors and large numbers of iterations are more stable than larger relaxation factors and smaller numbers of iterations.

virtual float vtkSmoothPolyDataFilter::GetRelaxationFactor | ( |  | ) | `[virtual]`

| Specify the relaxation factor for Laplacian smoothing. As in all iterative methods, the stability of the process is sensitive to this parameter. In general, small relaxation factors and large numbers of iterations are more stable than larger relaxation factors and smaller numbers of iterations.

virtual void vtkSmoothPolyDataFilter::SetFeatureEdgeSmoothing | ( | int |  | ) | `[virtual]`

| Turn on/off smoothing along sharp interior edges.

virtual int vtkSmoothPolyDataFilter::GetFeatureEdgeSmoothing | ( |  | ) | `[virtual]`

| Turn on/off smoothing along sharp interior edges.

virtual void vtkSmoothPolyDataFilter::FeatureEdgeSmoothingOn | ( |  | ) | `[virtual]`

| Turn on/off smoothing along sharp interior edges.

virtual void vtkSmoothPolyDataFilter::FeatureEdgeSmoothingOff | ( |  | ) | `[virtual]`

| Turn on/off smoothing along sharp interior edges.

virtual void vtkSmoothPolyDataFilter::SetFeatureAngle | ( | float |  | ) | `[virtual]`

| Specify the feature angle for sharp edge identification.

virtual float vtkSmoothPolyDataFilter::GetFeatureAngle | ( |  | ) | `[virtual]`

| Specify the feature angle for sharp edge identification.

virtual void vtkSmoothPolyDataFilter::SetEdgeAngle | ( | float |  | ) | `[virtual]`

| Specify the edge angle to control smoothing along edges (either interior or boundary).

virtual float vtkSmoothPolyDataFilter::GetEdgeAngle | ( |  | ) | `[virtual]`

| Specify the edge angle to control smoothing along edges (either interior or boundary).

virtual void vtkSmoothPolyDataFilter::SetBoundarySmoothing | ( | int |  | ) | `[virtual]`

| Turn on/off the smoothing of vertices on the boundary of the mesh.

virtual int vtkSmoothPolyDataFilter::GetBoundarySmoothing | ( |  | ) | `[virtual]`

| Turn on/off the smoothing of vertices on the boundary of the mesh.

virtual void vtkSmoothPolyDataFilter::BoundarySmoothingOn | ( |  | ) | `[virtual]`

| Turn on/off the smoothing of vertices on the boundary of the mesh.

virtual void vtkSmoothPolyDataFilter::BoundarySmoothingOff | ( |  | ) | `[virtual]`

| Turn on/off the smoothing of vertices on the boundary of the mesh.

virtual void vtkSmoothPolyDataFilter::SetGenerateErrorScalars | ( | int |  | ) | `[virtual]`

| Turn on/off the generation of scalar distance values.

virtual int vtkSmoothPolyDataFilter::GetGenerateErrorScalars | ( |  | ) | `[virtual]`

| Turn on/off the generation of scalar distance values.

virtual void vtkSmoothPolyDataFilter::GenerateErrorScalarsOn | ( |  | ) | `[virtual]`

| Turn on/off the generation of scalar distance values.

virtual void vtkSmoothPolyDataFilter::GenerateErrorScalarsOff | ( |  | ) | `[virtual]`

| Turn on/off the generation of scalar distance values.

virtual void vtkSmoothPolyDataFilter::SetGenerateErrorVectors | ( | int |  | ) | `[virtual]`

| Turn on/off the generation of error vectors.

virtual int vtkSmoothPolyDataFilter::GetGenerateErrorVectors | ( |  | ) | `[virtual]`

| Turn on/off the generation of error vectors.

virtual void vtkSmoothPolyDataFilter::GenerateErrorVectorsOn | ( |  | ) | `[virtual]`

| Turn on/off the generation of error vectors.

virtual void vtkSmoothPolyDataFilter::GenerateErrorVectorsOff | ( |  | ) | `[virtual]`

| Turn on/off the generation of error vectors.

void vtkSmoothPolyDataFilter::SetSource | ( | vtkPolyData * | source | ) |

| Specify the source object which is used to constrain smoothing. The source defines a surface that the input (as it is smoothed) is constrained to lie upon.

vtkPolyData* vtkSmoothPolyDataFilter::GetSource | ( |  | ) |

| Specify the source object which is used to constrain smoothing. The source defines a surface that the input (as it is smoothed) is constrained to lie upon.

void vtkSmoothPolyDataFilter::Execute | ( |  | ) | `[protected, virtual]`

| This method is the old style execute method Reimplemented from vtkSource.

## Member Data Documentation

float vtkSmoothPolyDataFilter::Convergence`[protected]`

| Definition at line 210 of file vtkSmoothPolyDataFilter.h.

int vtkSmoothPolyDataFilter::NumberOfIterations`[protected]`

| Definition at line 211 of file vtkSmoothPolyDataFilter.h.

float vtkSmoothPolyDataFilter::RelaxationFactor`[protected]`

| Definition at line 212 of file vtkSmoothPolyDataFilter.h.

int vtkSmoothPolyDataFilter::FeatureEdgeSmoothing`[protected]`

| Definition at line 213 of file vtkSmoothPolyDataFilter.h.

float vtkSmoothPolyDataFilter::FeatureAngle`[protected]`

| Definition at line 214 of file vtkSmoothPolyDataFilter.h.

float vtkSmoothPolyDataFilter::EdgeAngle`[protected]`

| Definition at line 215 of file vtkSmoothPolyDataFilter.h.

int vtkSmoothPolyDataFilter::BoundarySmoothing`[protected]`

| Definition at line 216 of file vtkSmoothPolyDataFilter.h.

int vtkSmoothPolyDataFilter::GenerateErrorScalars`[protected]`

| Definition at line 217 of file vtkSmoothPolyDataFilter.h.

int vtkSmoothPolyDataFilter::GenerateErrorVectors`[protected]`

| Definition at line 218 of file vtkSmoothPolyDataFilter.h.

vtkSmoothPoints* vtkSmoothPolyDataFilter::SmoothPoints`[protected]`

| Definition at line 220 of file vtkSmoothPolyDataFilter.h.

The documentation for this class was generated from the following file:

- Graphics/vtkSmoothPolyDataFilter.h